<?php declare(strict_types = 1);

require_once __DIR__ . "/../vendor/autoload.php";

use Grifart\Mappi\Cursor;

// using PostgreSQL 9.5 cursor simulation using in-memory data
$driver = new \Grifart\Mappi\Tests\Cursor\Driver\ArrayCursorDriver();
$driver->createTestCursor("test-cursor", 26684);

// cursor allow to do basic operations
$cursor = new Cursor\Cursor($driver, "test-cursor");

// tracked cursor can tell current position
$trackedCursor = new Cursor\TrackedCursor($cursor, Cursor\Position::fromLeft(0));

// semantic cursor provides nicer API for cursor
$semanticCursor = new Cursor\SemanticTrackedCursor($trackedCursor);

echo "<pre>\n";

echo "first row: " . print_r($semanticCursor->fetchNext(), true) . "\n";


$start = 547;
$limit = 20;

echo "position before move: " . $trackedCursor->getPosition() . "\n";
$semanticCursor->moveTo(547);
echo "position after move: " . $trackedCursor->getPosition() . "\n";

echo "\nposition\tvalue\n";
$i = $start;
foreach($trackedCursor->fetchRange($limit) as $row) {
	$i++;
	/** @var array $row */
	echo $i . "\t\t" . json_encode($row) . "\n";
}
echo "\n";
echo "position after fetchRange(): " . $trackedCursor->getPosition() . "\n";

echo "There is " . $semanticCursor->getTotal() . " rows in the data set\n";
echo "position after getTotal(): " . $trackedCursor->getPosition() . "\n";

echo "</pre>";
