<?php declare(strict_types = 1);
/**
 * This file is part of mappi/cursor.
 */

namespace Grifart\Mappi\Cursor;

/**
 * Semantic cursor with tracked extensions
 * @todo remove inheritance and use composition instead
 * @todo add tests
 * @package Grifart\Mappi\Cursor
 */
class SemanticTrackedCursor extends SemanticCursor
{
	/** @var TrackedCursor */
	protected $cursor;

	/**
	 * @param TrackedCursor $cursor
	 */
	public function __construct(TrackedCursor $cursor)
	{
		parent::__construct($cursor);
	}

	public function getPosition() : Position
	{
		return $this->cursor->getPosition();
	}

	/**
	 * Get total number of rows in cursor
	 * Caution! This will scroll through cursor to the BEGINNING or to the END
	 * @return int the number of rows in cursor
	 */
	public function getTotal() : int
	{
		$fromLeft = $this->cursor->getPosition()->getOrigin()->is(PositionOrigin::FROM_LEFT);
		if($fromLeft) {
			$this->scrollToEnd();
		} else {
			$this->scrollToBeginning();
		}
		return $this->cursor->getPosition()->getPosition() - 1;
	}

}