<?php
/**
 * @testCase
 */

namespace Grifart\Mappi\Tests\Cursor;

use Dibi\DriverException;
use Grifart\Mappi\Cursor\Driver\PostgresCursorFactory;
use Grifart\Mappi\Cursor\ICursor;
use Tester\Environment;

require_once __DIR__ . "/../bootstrap.php";
require_once __DIR__ . "/ICursorTest.php";

class PostgresCursorTest extends ICursorTest
{
	/** @var ICursor */
	protected $uut;

	protected function setUp()
	{
		global $connection, $SQL_thousandRowsAscending;
		try{
			$connection->begin();

			$factory = new PostgresCursorFactory($connection);
			$this->uut = $factory->create($SQL_thousandRowsAscending, true);
		} catch (DriverException $e) {
			Environment::skip("It looks like you haven't properly set-up dibi connection to PostgreSQL. Check tests/bootstrap.php");
		}

		parent::setUp();
	}

	public function tearDown()
	{
		global $connection;
		$connection->rollback();

		parent::tearDown();
	}

}

(new PostgresCursorTest())->run();
