<?php
/**
 * @testCase
 */

namespace Grifart\Mappi\Tests\Cursor;

use Grifart\Mappi\Cursor\Cursor;
use Grifart\Mappi\Cursor\SemanticCursor;
use Mockery;

require_once __DIR__ . "/../bootstrap.php";
require_once __DIR__ . "/ICursorTest.php";

/**
 * Behavioral test for SemanticCursor using mocking.
 * @link http://docs.mockery.io/en/latest/
 *
 * @package Grifart\Mappi\Tests\Cursor
 */
class SemanticCursorIntegrationTest extends ICursorTest
{

	/** @var SemanticCursor */
	protected $uut;

	protected function setUp()
	{
		$driver = new Driver\ArrayCursorDriver();
		$driver->createTestCursor("test", 1000);
		$cursor = new Cursor(
			$driver,
			"test"
		);
		$this->uut = new SemanticCursor(
			$cursor
		);

		parent::setUp();
	}

}

(new SemanticCursorIntegrationTest())->run();
